#include <stdio.h>

#define BUFFER 100

unsigned int randaux() {
    static long seed = 1;
    return (((seed = seed * 214013L + 2531011L) >> 16) & 0x7fff);
}

/* Implementação do procedimento MostraLamberta */
void MostraLamberta(int tabuleiro[], int tamanho) {
    char tabuleiroox[tamanho];
    int i;

    /* Mostra a linha dos decimais, caso existam */
    if (tamanho > 9) {
        for (i = 0; i < tamanho; i++) {
            if ((i + 1) % 10 == 0) {
                printf("%d", (i + 1) / 10);
            } else {
                printf(" ");
            }
        }
        printf("\n");
    }

    /* Mostra a linha das unidades e o tabuleiro do jogo */
    for (i = 0; i < tamanho; i++) {
        printf("%d", (i + 1) % 10);

        if (tabuleiro[i] % 2 == 0) {
            tabuleiroox[i] = 'O';
        } else {
            tabuleiroox[i] = 'X';
        }
    }
    tabuleiroox[tamanho] = '\0';
    printf("\n%s\n", tabuleiroox);
}


void main() {
    int i, saltos, tamanho, jogada, casa, elementos, verificax, parajogo, tabuleiro[BUFFER];
    scanf("%d %d", &tamanho, &saltos);


    // Saltar os primeiros números aleatórios, para ter sequências distintas
    for (i = 0; i < saltos; i++)
        randaux();

    // Gerar os numeros aleatórios
    for (i = 0; i < tamanho; i++)
        tabuleiro[i] = randaux();

    /* Chamar o procedimento para gerar um novo tabuleiro */
    MostraLamberta(tabuleiro, tamanho);

    /* Pedir a jogada ao jogador e verificar a jogada */
    parajogo = 0;
    for (jogada = 1; parajogo != 1; jogada++) {
        printf("Jogada [%d]:", jogada);
        scanf("%d %d", &casa, &elementos);
        printf("%d %d\n", casa, elementos);

        /* Verificar se a jogada contém 'X' e trocar os X e O no segmento */
        verificax = 0;
        for (i = casa; i < casa + elementos; i++) {
            if (tabuleiro[i - 1] % 2 != 0) {
                verificax = 1;
            }
            tabuleiro[i - 1] += 1;
        }

        /* Verificar se a jogada é válida e mostrar output correspondente*/
        if (verificax == 1 && (elementos <= tamanho - jogada || elementos == 1) && casa + elementos <= tamanho + 1) {
            MostraLamberta(tabuleiro, tamanho);
        } else {
            if (jogada % 2 != 0) {
                printf("Jogada inválida, perde jogador 1.");
            } else {
                printf("Jogada inválida, perde jogador 2.");
            }
            parajogo = 1;
        }
    }
}