#include <stdio.h>

#define BUFFER 100

unsigned int randaux() {
    static long seed = 1;
    return (((seed = seed * 214013L + 2531011L) >> 16) & 0x7fff);
}

/* Implementação do procedimento MostraLamberta */
void MostraLamberta(int tabuleiro[], int tamanho) {
    char tabuleiroox[tamanho];
    int i;

    /* Mostra a linha dos decimais, caso existam */
    if (tamanho > 9) {
        for (i = 0; i < tamanho; i++) {
            if ((i + 1) % 10 == 0) {
                printf("%d", (i + 1) / 10);
            } else {
                printf(" ");
            }
        }
        printf("\n");

    }

    /* Mostra a linha das unidades e o tabuleiro do jogo */
    for (i = 0; i < tamanho; i++) {
        printf("%d", (i + 1) % 10);

        if (tabuleiro[i] % 2 == 0) {
            tabuleiroox[i] = 'O';
        } else {
            tabuleiroox[i] = 'X';
        }
    }
    tabuleiroox[tamanho] = '\0';
    printf("\n%s\n", tabuleiroox);
}

/* Implementação do procedimento testaregras */
void testaregras(int tamanho, int jogada, int *casa, int *elementos, int tabuleiro[]) {
    int contax, i, j, conta[BUFFER], contabloco;
    contax = 0;
    *casa = 0;
    *elementos = 1;

    /* Verificar se o tabuleiro tem X e contálos */
    for (i = 0; i < tamanho; i++) {
        if (tabuleiro[i] % 2 != 0) {
            contax += 1;
        }
    }
    /* Inicia o teste das regras */
    /* Testar a regra 5 */
    if (contax == 0) {
        printf(" -regra 5- ");
    } else {
        /* Testar a regra 1 */
        if (tamanho - jogada <= 1) {
            for (i = 0; i < tamanho && (tabuleiro[i] % 2 == 0); i++) {
                *casa = i + 1;
            }
            printf(" -regra 1- ");
        } else {
            /* Testar a regra 2 */
            contabloco = 0;
            for (i = 0; i < tamanho; i++) {
                if (tabuleiro[i] % 2 != 0) {
                    conta[i] = 1;
                    for (j = i; (((tabuleiro[j] % 2) == (tabuleiro[j + 1] % 2)) && j != tamanho - 1); j++) {
                        conta[i] += 1;
                    }
                    j = j - conta[i] + 1;
                    i += conta[i];
                    contabloco += 1;
                }
            }
            if ((contabloco == 1) && ((conta[j]) <= tamanho - jogada)) {
                *casa = (j);
                *elementos = conta[j];
                printf(" -regra 2- ");
            } else {
                /* Testar a regra 3 */
                if (tamanho - jogada == 2) {
                    for (i = 0; (i < tamanho) && (tabuleiro[i] % 2 == 0); i++) {
                    }
                    if (contax % 2 == 0) {
                        if (i == 0) {
                            *casa = i;
                        } else {
                            *casa = i - 1;
                        }
                        *elementos = 2;
                    } else {
                        *casa = i;
                    }
                    printf(" -regra 3- ");
                } else {
                    /* Testar a regra 4 */
                    for (i = 0; (i + (tamanho - jogada) <= tamanho); i++) {
                        conta[i] = 0;
                        for (j = i; (j < i + tamanho - jogada - 1); j++) {
                            if ((tabuleiro[j] % 2) != (tabuleiro[j + 1] % 2)) {
                                conta[i] += 1;
                            }
                        }
                    }
                    for (i = 0; (i + (tamanho - jogada) < tamanho); i++) {
                        if (conta[*casa] < conta[i + 1]) {
                            *casa = i + 1;
                        }
                    }
                    *elementos = tamanho - jogada;
                    printf(" -regra 4- ");
                }
            }
        }
    }
}

void main() {
    int i, saltos, tamanho, jogada, casa, elementos, verificax, parajogo, tabuleiro[BUFFER];

    scanf("%d %d", &tamanho, &saltos);

    /* Saltar os primeiros números aleatórios, para ter sequências distintas */
    for (i = 0; i < saltos; i++)
        randaux();

    /* Gerar os numeros aleatórios */
    for (i = 0; i < tamanho; i++)
        tabuleiro[i] = randaux();

    /* Chamar o procedimento para gerar um novo tabuleiro */
    MostraLamberta(tabuleiro, tamanho);

    /* Iniciar a jogada, escolher a regra da jogada e testar a jogada logo de seguida */
    parajogo = 0;
    for (jogada = 1; parajogo != 1; jogada++) {

        printf("Jogada [%d]:", jogada);

        /* Chamar o procedimento para testar as regras */
        testaregras(tamanho, jogada, &casa, &elementos, tabuleiro);

        printf("%d %d\n", casa + 1, elementos);

        /* Verificar se a jogada contém 'X' e trocar os X e O no segmento */
        verificax = 0;
        for (i = casa; i < casa + elementos; i++) {
            if (tabuleiro[i] % 2 != 0) {
                verificax = 1;
            }
            tabuleiro[i] += 1;
        }

        /* Verificar se a jogada é válida e mostrar output correspondente */
        if (verificax == 1 && (elementos <= tamanho - jogada || elementos == 1) && casa + elementos <= tamanho) {
            MostraLamberta(tabuleiro, tamanho);
        } else {
            if (jogada % 2 != 0) {
                printf("Jogada inválida, perde jogador 1.");
            } else {
                printf("Jogada inválida, perde jogador 2.");
            }
            parajogo = 1;
        }
    }
}